SeExpr

Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
SeDeepWater< T > Struct Template Reference

`#include <ExprDeepWater.h>`

## Public Member Functions
| SeDeepWater ()
virtual | ~SeDeepWater ()
void | setParams (const SeDeepWaterParams &paramsIn)
T | sqr (T x)
T | toIndex (const T x)
T | fromIndex (const T index)
T | fromLog (const T x)
T | toLog (const T z)
T | powerLaw (const T x, const SeDeepWaterParams &params)
T | rescale (const T x)
void | generateSpectrum ()
T | getValue (double param) const
| Evaluates curve and returns full value. More...
T | getKLow ()
T | getKHigh ()
bool | inGrid ()

## Static Public Member Functions
static T | kscale ()
static T | bottom_offset ()

## Public Attributes
T | gravity
size_t | gridSize
SeDeepWaterParams | params
std::vector< T > | energy
T | klowindex
T | khighindex
T | kmaxindex

## Detailed Description

### template<class T>
struct SeDeepWater< T >

Definition at line 67 of file ExprDeepWater.h.

## Constructor & Destructor Documentation

## ◆ SeDeepWater()

template<class T >

SeDeepWater< T >::SeDeepWater | ( |  | ) |
| inline

Definition at line 68 of file ExprDeepWater.h.

## ◆ ~SeDeepWater()

template<class T >

virtual SeDeepWater< T >::~SeDeepWater | ( |  | ) |
| inline virtual

Definition at line 69 of file ExprDeepWater.h.

## Member Function Documentation

## ◆ bottom_offset()

template<class T >

static T SeDeepWater< T >::bottom_offset | ( |  | ) |
| inline static

Definition at line 86 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::fromLog(), and SeDeepWater< T >::toLog().

## ◆ fromIndex()

template<class T >

T SeDeepWater< T >::fromIndex | ( | const T | index | ) |
| inline

Definition at line 84 of file ExprDeepWater.h.

References index(), and SeDeepWater< T >::kscale().

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ fromLog()

template<class T >

T SeDeepWater< T >::fromLog | ( | const T | x | ) |
| inline

Definition at line 90 of file ExprDeepWater.h.

References SeDeepWater< T >::bottom_offset(), and x.

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ generateSpectrum()

template<class T >

void SeDeepWater< T >::generateSpectrum | ( |  | ) |
| inline

Definition at line 100 of file ExprDeepWater.h.

References SeDeepWaterParams::directionalFactorExponent, SeDeepWater< T >::energy, SeDeepWater< T >::fromIndex(), SeDeepWater< T >::fromLog(), SeDeepWater< T >::gravity, SeDeepWater< T >::gridSize, SeDeepWater< T >::khighindex, SeDeepWater< T >::klowindex, SeDeepWater< T >::kmaxindex, SeDeepWaterParams::lengthCutoff, SeDeepWater< T >::params, SeDeepWater< T >::powerLaw(), SeDeepWater< T >::rescale(), SeDeepWater< T >::sqr(), SeDeepWaterParams::tileSize, SeDeepWater< T >::toIndex(), SeDeepWater< T >::toLog(), SeDeepWaterParams::windSpeed, and x.

Referenced by DeepWaterScene::rebuildDeepWater().

## ◆ getKHigh()

template<class T >

T SeDeepWater< T >::getKHigh | ( |  | ) |
| inline

Definition at line 142 of file ExprDeepWater.h.

References SeDeepWater< T >::energy, and SeDeepWater< T >::khighindex.

Referenced by DeepWaterScene::drawGrid().

## ◆ getKLow()

template<class T >

T SeDeepWater< T >::getKLow | ( |  | ) |
| inline

Definition at line 137 of file ExprDeepWater.h.

References SeDeepWater< T >::energy, and SeDeepWater< T >::klowindex.

Referenced by DeepWaterScene::drawGrid().

## ◆ getValue()

template<class T >

T SeDeepWater< T >::getValue | ( | double | param | ) | const
| inline

Evaluates curve and returns full value.

Definition at line 129 of file ExprDeepWater.h.

References SeDeepWater< T >::energy, and index().

Referenced by DeepWaterScene::drawPoly().

## ◆ inGrid()

template<class T >

bool SeDeepWater< T >::inGrid | ( |  | ) |
| inline

Definition at line 147 of file ExprDeepWater.h.

References SeDeepWater< T >::khighindex, SeDeepWater< T >::klowindex, and SeDeepWater< T >::kmaxindex.

Referenced by DeepWaterScene::drawGrid().

## ◆ kscale()

template<class T >

static T SeDeepWater< T >::kscale | ( |  | ) |
| inline static

Definition at line 78 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::fromIndex(), and SeDeepWater< T >::toIndex().

## ◆ powerLaw()

template<class T >

T SeDeepWater< T >::powerLaw | ( | const T | x,
|  | const SeDeepWaterParams & | params
| ) |  |
| inline

Definition at line 94 of file ExprDeepWater.h.

References SeDeepWaterParams::amplitude, SeDeepWaterParams::directionalFactorExponent, SeDeepWater< T >::params, pow(), SeDeepWater< T >::sqr(), and x.

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ rescale()

template<class T >

T SeDeepWater< T >::rescale | ( | const T | x | ) |
| inline

Definition at line 98 of file ExprDeepWater.h.

References pow(), and x.

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ setParams()

template<class T >

void SeDeepWater< T >::setParams | ( | const SeDeepWaterParams & | paramsIn | ) |
| inline

Definition at line 71 of file ExprDeepWater.h.

References SeDeepWater< T >::gridSize, SeDeepWater< T >::params, and SeDeepWaterParams::resolution.

Referenced by DeepWaterScene::rebuildDeepWater().

## ◆ sqr()

template<class T >

T SeDeepWater< T >::sqr | ( | T | x | ) |
| inline

Definition at line 76 of file ExprDeepWater.h.

References x.

Referenced by SeDeepWater< T >::generateSpectrum(), and SeDeepWater< T >::powerLaw().

## ◆ toIndex()

template<class T >

T SeDeepWater< T >::toIndex | ( | const T | x | ) |
| inline

Definition at line 82 of file ExprDeepWater.h.

References SeDeepWater< T >::kscale(), and x.

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ toLog()

template<class T >

T SeDeepWater< T >::toLog | ( | const T | z | ) |
| inline

Definition at line 92 of file ExprDeepWater.h.

References SeDeepWater< T >::bottom_offset(), and z.

Referenced by SeDeepWater< T >::generateSpectrum().

## Member Data Documentation

## ◆ energy

template<class T >

std::vector<T> SeDeepWater< T >::energy

Definition at line 152 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), SeDeepWater< T >::getKHigh(), SeDeepWater< T >::getKLow(), and SeDeepWater< T >::getValue().

## ◆ gravity

template<class T >

T SeDeepWater< T >::gravity

Definition at line 149 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum().

## ◆ gridSize

template<class T >

size_t SeDeepWater< T >::gridSize

Definition at line 150 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), and SeDeepWater< T >::setParams().

## ◆ khighindex

template<class T >

T SeDeepWater< T >::khighindex

Definition at line 154 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), SeDeepWater< T >::getKHigh(), and SeDeepWater< T >::inGrid().

## ◆ klowindex

template<class T >

T SeDeepWater< T >::klowindex

Definition at line 153 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), SeDeepWater< T >::getKLow(), and SeDeepWater< T >::inGrid().

## ◆ kmaxindex

template<class T >

T SeDeepWater< T >::kmaxindex

Definition at line 155 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), and SeDeepWater< T >::inGrid().

## ◆ params

template<class T >

SeDeepWaterParams SeDeepWater< T >::params

Definition at line 151 of file ExprDeepWater.h.

Referenced by SeDeepWater< T >::generateSpectrum(), SeDeepWater< T >::powerLaw(), and SeDeepWater< T >::setParams().

The documentation for this struct was generated from the following file:

- /build/seexpr/src/SeExpr/src/SeExpr2/UI/ExprDeepWater.h